/*
 * lxcall-e.r.c
 * Copyright (C) 2012-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall-types.h>

int
_libx1f4i0_lxcall_line_side(void *data, void *tile,
			    const struct x1f4_operator_type *operator_line,
			    const char *const *names, unsigned slip)
{
    struct ticket_type *ticket_data;
    struct x1f4_operator_type **operator;
    unsigned i;

    ticket_data = data;
    ticket_data -= slip;

    operator = data;

    i = slip;
    for (; i; i--) {
	const char *name, *side;
	struct x1f4_linetext_type *linetext_data;

	side = *names++;
	linetext_data = tile;
	name = linetext_data->function.name;
	while (name) {
	    if (name == side) {
		break;
	    } else {
		linetext_data++;
		name = linetext_data->function.name;
	    }
	}
	if (name) {
	    *operator = &ticket_data->operator;

	    ticket_data->operator = *operator_line;
	    ticket_data->operator.args = linetext_data->function.args;
	    ticket_data->operator.type = linetext_data->function.type;

	    if (ticket_data->operator.extension2) {
		ticket_data->tidespan = *(struct x1f4_2ndscope_type *)
		    ticket_data->operator.extension2;
		ticket_data->tidespan.bits |= X1f4_E4_CALL_LINK;
	    } else {
		ticket_data->tidespan.bits = X1f4_E4_CALL_LINK;
	    }

	    ticket_data->operator.extension2 = &ticket_data->tidespan;

	    ticket_data->tidespan.line = linetext_data;

	    ticket_data++;

	    operator++;
	}

	operator_line++;
    }

    *operator = NULL;

    return 0;
}
