/*
 * lxdash-a.t.c
 * Copyright (C) 2008-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <lxfset.h>
#include <lxlead.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define dxdash(line) \
    ((struct dxdash_type *) (line))
#define lxdash(line) \
    ((struct lxdash_type *) (line))

int
_libx1f4i0_lxdash_late_line(void *subtext, void *late, void *copy,
			    const void *line)
{
    int status;
    struct lxdash_type *lxdash_data;

    lxdash_data = subtext;

    if (1) {
	void *becca[6];

	becca[0] = subtext;
	becca[2] = late;

	status = x1f4_init_lxfset(becca + 3);
	if (status) {
	    status = _libx1f4i0_lxdash_stat_link(lxdash_data);
	} else {
	    int excess;
	    void **node, *record;

	    status = x1f4_post_lxfset(becca[3], (void *) &line, &record);
	    if (status) {
		status = _libx1f4i0_lxdash_stat_link(lxdash_data);
	    } else {
		node = record;

		node[0] = (void *) line;
		node[1] = late;

		becca[4] = &lxdash_data->link_m;
		becca[5] = NULL;

		status = _libx1f4i0_line_lxfset
		    (dxdash(copy)->dash, dxdash(line)->dash,
		     _libx1f4i0_lxdash_copy_link, _libx1f4i0_lxdash_free_link,
		     becca);
		if (status) {
		    status =
			_libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);

		    x1f4_lose_lxlead(becca[5], &lxdash_data->link_m);
		} else {
		    dxdash(copy)->size = dxdash(line)->size;

		    status = x1f4_beta_lxlead
			(becca[3], becca[5], &lxdash_data->link_m);
		}
	    }

	    excess = x1f4_fini_lxfset(becca + 3);
	    if (excess) {
		status = _libx1f4i0_lxdash_stat_free(lxdash_data, status);
	    }
	}
    }

    return status;
}
