/*
 * lxdash-a.v.c
 * Copyright (C) 2008-2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxdash-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define becca(context) \
    ((void **) (context))
#define scope(context) \
    (becca((context)) + 2)

#define lxdash(line) \
    ((struct lxdash_type *) (line))

int
_libx1f4i0_lxdash_free_link(void *context, void *line)
{
    int status = 0;
    struct effect_type *effect_data;
    unsigned link;

    effect_data = line;

    link = effect_data->link;
    if (~link) {
	int (*free) (void *, void *, struct x1f4_nodelink_type **,
		     const struct excase_type *);
	struct lxdash_type *lxdash_data;
	struct lxtext_type *lxtext_link;

	lxdash_data = *becca(context);

	lxtext_link = (struct lxtext_type *) lxdash_data->link_f.text + link;

	free = lxtext_link->lxtype.free;
	if (free) {
	    status = free
		(lxtext_link->lxtype.context, I_USER(&effect_data->fxdata),
		 NULL, lock_excase(*scope(context)));
	}
    }

    return status;
}
