/*
 * lxdash-inter.h
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxdash_inter_H__
#define __LIBx1f4_lxdash_inter_H__

#include <cl.h>
#include <dt.h>
#include <e4.h>
#include <lxdash-types.h>
#include <lxplus.h>
#include <lxnorm.h>
#include <lxwide.h>
#include <nt.h>
#include <trans.h>

#define _libx1f4i0_lxdash_bset_line	x1f4_bset_lxdash
#define _libx1f4i0_lxdash_cfix_line	x1f4_cfix_lxdash
#define _libx1f4i0_lxdash_clip_line	x1f4_clip_lxdash
#define _libx1f4i0_lxdash_copy_line	x1f4_copy_lxdash
#define _libx1f4i0_lxdash_deck_line	x1f4_deck_lxdash
#define _libx1f4i0_lxdash_dset_line	x1f4_dset_lxdash
#define _libx1f4i0_lxdash_dump_line	x1f4_dump_lxdash
#define _libx1f4i0_lxdash_fini_line	x1f4_fini_lxdash
#define _libx1f4i0_lxdash_flat_line	x1f4_flat_lxdash
#define _libx1f4i0_lxdash_free_line	x1f4_free_lxdash
#define _libx1f4i0_lxdash_fset_line	x1f4_fset_lxdash
#define _libx1f4i0_lxdash_hash_line	x1f4_hash_lxdash
#define _libx1f4i0_lxdash_init_line	x1f4_init_lxdash
#define _libx1f4i0_lxdash_lead_line	x1f4_lead_lxdash
#define _libx1f4i0_lxdash_line_line	x1f4_line_lxdash
#define _libx1f4i0_lxdash_link_line	x1f4_link_lxdash
#define _libx1f4i0_lxdash_miss_line	x1f4_miss_lxdash
#define _libx1f4i0_lxdash_near_line	x1f4_near_lxdash
#define _libx1f4i0_lxdash_node_line	x1f4_node_lxdash
#define _libx1f4i0_lxdash_post_line	x1f4_post_lxdash
#define _libx1f4i0_lxdash_pull_line	x1f4_pull_lxdash
#define _libx1f4i0_lxdash_seek_line	x1f4_seek_lxdash
#define _libx1f4i0_lxdash_slip_line	x1f4_slip_lxdash
#define _libx1f4i0_lxdash_tile_line	x1f4_tile_lxdash
#define _libx1f4i0_lxdash_type_line	x1f4_type_lxdash
#define _libx1f4i0_lxdash_vset_line	x1f4_vset_lxdash

#define __types_lock(lxdash) \
    (&__types_long(lxdash)->east_1)

#define __types_long(lxdash) \
    (&((struct lxdash_type *) (lxdash))->ever_r.over_1.rule_1.nice_1)

#define _libx1f4i0_lxdash_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_lock((___l)), (___1))
#define _libx1f4i0_lxdash_stat_land(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_land(__types_lock((___l)), (___1), (___2))
#define _libx1f4i0_lxdash_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxdash_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_lock((___l)))
#define _libx1f4i0_lxdash_stat_roll(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_roll(__types_lock((___l)), (___1), (___2))
#define _libx1f4i0_lxdash_stat_zero(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_zero(__types_lock((___l)), (___1), (___2))

#define _libx1f4i0_lxdash_s_forward	_libx1f4i0_lxnorm_s_forward

extern int _libx1f4i0_lxdash_0_centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_0_point_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_0_point_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_0_point_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_0_point_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_0_point_u
    (void *, void *, void **, int (*)(void *, void *, void **));
extern int _libx1f4i0_lxdash_0_point_v
    (void *, void *, void **, int (*)(void *, void *, void **));
extern int _libx1f4i0_lxdash_0k_queued(void *, void *, void **);
extern int _libx1f4i0_lxdash_1_centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_break_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_break_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_break_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_a_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdash_b_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_b_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdash_bset_line
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxdash_c_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_c_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdash_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_c_nearest(void *, void *, void **);
extern int _libx1f4i0_lxdash_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxdash_c_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdash_cfix_line(void *, unsigned, void *);
extern int _libx1f4i0_lxdash_clip_line
    (unsigned, const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxdash_copy_link(void *, void *, const void *);
extern int _libx1f4i0_lxdash_copy_line
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxdash_copy_text
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxdash_d_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_d_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_d_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_d_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdash_down_line(void *, void *, void *);
extern int _libx1f4i0_lxdash_dset_line
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxdash_dump_line(void *, struct excase_type *);
extern int _libx1f4i0_lxdash_e0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_e0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_e0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_e0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_press_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_press_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_e_press_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_ebclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_ebclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_efclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_efclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_f1centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_f_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdash_fast_line(void *, void *);
extern int _libx1f4i0_lxdash_fine_line(void *, void *);
extern int _libx1f4i0_lxdash_fini_line(void **);
extern int _libx1f4i0_lxdash_flat_line(void *, void **);
extern int _libx1f4i0_lxdash_free_link(void *, void *);
extern int _libx1f4i0_lxdash_free_line
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxdash_free_text
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxdash_fset_line
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxdash_g0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_g0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_g0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_g0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_point_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_point_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_press_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_press_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_g_press_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_gbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_gbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_gfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_gfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_gk_queued(void *, void *, void **);
extern int _libx1f4i0_lxdash_h_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdash_hash_line
    (void *, struct excase_type **, struct excase_type *);
extern int _libx1f4i0_lxdash_heap_line(void *, struct excase_type **, void *);
extern int _libx1f4i0_lxdash_i_pending(void *, void *, void **);
extern int _libx1f4i0_lxdash_init_line
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxdash_j_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_j_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_j_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_j_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_j_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_j_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_j_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_k_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_k_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_keep_call
    (void **, void **, unsigned, int *, const int *, unsigned, int, int, int);
extern int _libx1f4i0_lxdash_l_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_l_point_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_l_point_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_l_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdash_late_line
    (void *, void *, void *, const void *);
extern int _libx1f4i0_lxdash_lead_line(void *, void **);
extern int _libx1f4i0_lxdash_lead_text(void *, void **);
extern int _libx1f4i0_lxdash_line_line(void *, void **);
extern int _libx1f4i0_lxdash_link_link(void *, void *, const void *);
extern int _libx1f4i0_lxdash_link_line(void *, void **);
extern int _libx1f4i0_lxdash_lk_queued(void *, void *, void **);
extern int _libx1f4i0_lxdash_m_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_n_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_near_line(void *);
extern int _libx1f4i0_lxdash_node_line
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxdash_null_line
    (void *, struct excase_type **, void *);
extern int _libx1f4i0_lxdash_o_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_point_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_o_point_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_ok_queued(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_pending(void *, void *, void **);
extern int _libx1f4i0_lxdash_p_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdash_post_line
    (void *, void **, const struct excase_type *);
extern int _libx1f4i0_lxdash_pull_line
    (void *, void *, void *, const void *, struct trans_type *,
     struct x1f4_caselink_type **);
extern int _libx1f4i0_lxdash_push_text
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxdash_q0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_q0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_q0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_q0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_press_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_press_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_q_press_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_qbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_qbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_qfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_qfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_derived(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_s_pending(void *, void *, void **);
extern int _libx1f4i0_lxdash_s_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdash_seek_line(const void *);
extern int _libx1f4i0_lxdash_side_line(void *, void *);
extern int _libx1f4i0_lxdash_slip_line(void *, void **);
extern int _libx1f4i0_lxdash_slip_text(void *, void **);
extern int _libx1f4i0_lxdash_spin_line(void *, void *, void *);
extern int _libx1f4i0_lxdash_stat_ends(void *, int, unsigned, unsigned);
extern int _libx1f4i0_lxdash_stat_even(void *);
extern int _libx1f4i0_lxdash_stat_ever(void *);
extern int _libx1f4i0_lxdash_stat_flat(void *, long);
extern int _libx1f4i0_lxdash_stat_line(void *, int, int);
extern int _libx1f4i0_lxdash_stat_lock(void *, int);
extern int _libx1f4i0_lxdash_stat_miss(void *, long);
extern int _libx1f4i0_lxdash_stat_null(void *);
extern int _libx1f4i0_lxdash_stat_odds(void *);
extern int _libx1f4i0_lxdash_stat_post(void *, long);
extern int _libx1f4i0_lxdash_stat_text(void *, int, long);
extern int _libx1f4i0_lxdash_stat_type(void *, long, unsigned, unsigned);
extern int _libx1f4i0_lxdash_swap_line(void *, void *);
extern int _libx1f4i0_lxdash_t_centric(void *, void *, void **);
extern int _libx1f4i0_lxdash_t_pending(void *, void *, void **);
extern int _libx1f4i0_lxdash_tile_line
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxdash_type_line(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxdash_u_forward(void *, void *, void **);
extern int _libx1f4i0_lxdash_u_point_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_u_point_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_uk_queued(void *, void *, void **);
extern int _libx1f4i0_lxdash_v_logique(void *, void *, void **);
extern int _libx1f4i0_lxdash_w_pending(void *, void *, void **);
extern int _libx1f4i0_lxdash_will_list
    (void *, void *, void **, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, int, void *);
extern int _libx1f4i0_lxdash_x0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_x0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_x0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_x0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_class_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_class_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_class_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_class_t(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_class_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_class_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_press_b(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_press_m(void *, void *, void **);
extern int _libx1f4i0_lxdash_x_press_r(void *, void *, void **);
extern int _libx1f4i0_lxdash_xbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_xbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_xfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdash_xfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdash_y_derived(void *, void *, void **);

#endif				/* __LIBx1f4_lxdash_inter_H__ */
