/*
 * lxdecq-a.v.c
 * Copyright (C) 2008, 2009, 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxdecq-drive.h>
#include <lxdecq-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define becca(context) \
    ((void **) (context))
#define scope(context) \
    (becca((context)) + 2)

#define lxdecq(list) \
    ((struct lxdecq_type *) (list))

int
_libx1f4i0_lxdecq_free_link(void *context, void *list)
{
    int status;
    unsigned link;

    link = byte(list)[4] << 030 | byte(list)[5] << 020 | byte(list)[6] << 010
	| byte(list)[7];
    if (~link) {
	int (*free) (void *, void *, struct x1f4_nodelink_type **,
		     const struct excase_type *);
	struct lxtext_type *lxtext_link;

	lxtext_link =
	    (struct lxtext_type *) lxdecq(*becca(context))->link_f.text + link;

	free = lxtext_link->lxtype.free;
	if (free) {
	    status = free
		(lxtext_link->lxtype.context,
		 I_USER(byte(list) + 8), NULL, lock_excase(*scope(context)));
	} else {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
