/*
 * lxlist-u.j.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxcall.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxlist_j_class_u(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;
    int status;
    struct dxlist_type *dxlist_data;
    struct lxtext_type *lxtext_data;
    unsigned size;

    lxtext_data = context;

    dxlist_data = I_LIST(input[1]);

    mode = I_MODE(input[2]);

    size = dxlist_data->size;
    if (mode < -(X1f4_E4_C_MODE) (int) size
	|| !(mode < (X1f4_E4_C_MODE) (int) size)) {
	l_MODE(0, output);

	status = 0;
    } else {
	void *data;

	if (mode < 0) {
	    mode += size;
	}

	status = _libx1f4i0_peek_l4list(dxlist_data->list, mode, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(lxtext_data->text, 0, status);
	} else {
	    unsigned type;

	    type = effect_type(data);
	    if (type != lxtext_data->lxtype.code) {
		l_MODE(0, output);
	    } else {
		X1f4_E4_C_USER user;

		user = I_USER(byte(data) + 8);
		if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		    status = _libx1f4i0_lxcall_side_node
			(&lxtext_data->lxtype, user, input[0]);
		    if (status) {
		    } else {
			l_MODE(1, output);
		    }
		} else {
		    l_MODE(1, output);

		    l_USER(user, input[0]);
		}
	    }
	}
    }

    return status;
}
