/*
 * lxnote.h
 * Copyright (C) 2010-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxnote_H__
#define __LIBx1f4_lxnote_H__

#include <dt.h>
#include <e4.h>
#include <lxwide.h>
#include <nt.h>

struct x1f4_indexset_type;

typedef struct x1f4_lxnote_type {
    int (*bset)(void *, const struct x1f4_operator_type **),
	(*cfix)(void *, unsigned, void *),
	(*clip)(unsigned, const void *, struct x1f4_nodetype_type **, int *),
	(*dset)(void *, const struct x1f4_datatype_type **),
	(*fini)(void **),
	(*fset)(void *, const struct x1f4_linetext_type **),
	(*lift)(void *, int, void **), (*near)(void *),
	(*seek)(const void *),
	(*tile)(void **, unsigned, struct x1f4_lxwide_type *, unsigned,
		const void *), (*vset)(void *, void **),
	(*wrap)(void *, struct x1f4_indexset_type *);
    unsigned bits;
} x1f4_lxnote_type;

#endif				/* __LIBx1f4_lxnote_H__ */
