/*
 * lxpoll-l.r.c
 * Copyright (C) 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_e101.h>
#include <e4.h>
#include <lxfset.h>
#include <lxpoll-defs.h>
#include <lxpoll-inter.h>
#include <lxpoll-types.h>

#define I_FILE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_POLL(t)			(*((X1f4_E4_C_USER *) (t)))

static int slip_line(void *, void *);

static int
slip_line(void *method, void *agenda)
{
    return 0;
}


int
_libx1f4i0_lxpoll_r_logique(void *context, void *output, void **input)
{
    int status;
    struct dxpoll_type *dxpoll_data;
    void *data, *file;

    dxpoll_data = I_POLL(input[0]);

    file = I_FILE(input[1]);

    status = x1f4_find_lxfset(f_direct(dxpoll_data), &file, &data);
    if (status) {
	do {
	    struct Mylene101_access_type *access_data;

	    access_data = *((void **) data + 1);

	    if (Mylene101_case_access(dxpoll_data->device, access_data)
		== Mylene101_SEND_CLASS) {
	    } else {
		unsigned bits;
		void **track;

		track = access_data->text;
		bits = (integral_q) track[BITS_LEAD];
		if (bits & LIVE_LINE) {
		    struct Mylene101_access_type *access_data;
		    struct Mylene101_agenda_type agenda;
		    struct timeval effect;

		    effect.tv_sec = 0;
		    effect.tv_usec = 0;

		    access_data = track[PICK_LEAD];

		    agenda.fini = access_data->fini;
		    agenda.fare = slip_line;
		    agenda.text = track;

		    access_data->fini = NULL;

		    status = Mylene101_slip_access
			(dxpoll_data->device, NULL, access_data);
		    if (status) {
			status = _libx1f4i0_lxpoll_stat_poll
			    (context, 0, dxpoll_data, status);

			break;
		    }

		    status = _libx1f4i0_cast_lxfset
			(f_direct(dxpoll_data), &file);
		    if (status) {
			status = _libx1f4i0_lxpoll_stat_free(context, 0);

#if 0
			/*
			 * seems wrong to deregister at this time, function
			 * call in progress and all.
			 */
			slip_line(NULL, track);
#endif				/* 0 */

			break;
		    }

		    track[NODE_LEAD + 1] = NULL;

		    status = Mylene101_push_agenda
			(dxpoll_data->device, &effect, &agenda, NULL);
		    if (status) {
			status = _libx1f4i0_lxpoll_stat_poll
			    (context, 0, dxpoll_data, status);
		    }

		    break;
		}
	    }

	    status = Mylene101_slip_access
		(dxpoll_data->device, NULL, access_data);
	    if (status) {
		status = _libx1f4i0_lxpoll_stat_poll
		    (context, 0, dxpoll_data, status);
	    }
	} while (0);
    } else {
	status = _libx1f4i0_lxpoll_stat_miss(context);
    }

    return status;
}
