/*
 * qsce.a.c
 * Copyright (C) 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qscc-defs.h>
#include <qscc-inter.h>
#include <qscc-names.h>
#include <qscc-types.h>

#define qsrate(qsrate)			((struct qsrate_type *) (qsrate))

static int miss_rate(struct qsrate_type *);

static int
miss_rate(struct qsrate_type *qsrate_data)
{
    int status;

    status = qsrate_data->link_m.free
	(qsrate_data->link_m.data, qsrate_data->link_a.fplist.fpnode);
    if (status) {
	status = FREE_ERROR;
    } else {
	int excess;
	void *node;

	node = qsrate_data->link_e.fplink_text;

	qsrate_data->link_e.fplink_text = NULL;

	qsrate_data->link_a.fplist.rate = 0;

	if (node) {
	    status = qsrate_data->link_m.mode
		(qsrate_data->link_m.data, &node,
		 qsrate_data->link_a.fplist.line * 3
		 * qsrate_data->link_a.fplist.mall >> 1);
	    if (status) {
		status = MODE_ERROR;
	    }
	} else {
	    status = qsrate_data->link_m.link
		(qsrate_data->link_m.data, &node,
		 qsrate_data->link_a.fplist.line * 3
		 * qsrate_data->link_a.fplist.mall >> 1);
	    if (status) {
		status = LINK_ERROR;
	    }
	}

	qsrate_data->link_a.fplist.fpnode = node;

	excess = _libx1f4l2_fade_qsrate(qsrate_data);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}

	qsrate_data->link_e.fplink_data = NULL;
    }

    return status;
}


int
x1f4_dash_qsrate(void *qsrate, unsigned head, unsigned tail)
{
    int status;
    unsigned count;

    count = qsrate(qsrate)->link_a.fplist.size;

    if (head < count && head < tail + 1 && tail < count) {
	int able;
	unsigned lock, part, rate;

	rate = qsrate(qsrate)->link_a.fplist.rate;

	tail++;

	lock = qsrate(qsrate)->link_a.fplist.lock;

	status = _libx1f4l2_pose_qsrate
	    (qsrate, lock, rate, 0, head, tail, count,
	     &qsrate(qsrate)->link_a.fplist.fpnode,
	     &qsrate(qsrate)->link_a.fplist.node, &able, &part);
	if (status) {
	} else {
	    qsrate(qsrate)->link_a.fplist.size = count - tail + head;
	    if (rate) {
		if (qsrate(qsrate)->link_a.fplist.node < 2) {
		    if (qsrate(qsrate)->link_a.fplist.node) {
			status =
			    _libx1f4l2_wrap_qsrate(qsrate, lock, rate - 1);
		    } else {
			status = miss_rate(qsrate);
		    }
		}
	    }
	}
    } else {
	status = DECK_ERROR;
    }

    return status;
}
